/**
 * Class of colored points in a plane with encapsulated variables
 * and a method to calculate the distance to another point
 */
class Point {

	// instance variables
	private int x, y;
	private String color;

	// Constructors
	Point() {
		x = 0;
		y = 0;
	}

	Point(int xInit, int yInit) {
		x = xInit;
		y = yInit;
	}

	Point(int xInit, int yInit, String colorInit) {
		x = xInit;
		y = yInit;
		color = colorInit;
	}

	// methods for querying the variables
	int getX() {
		return x;
	}

	int getY() {
		return y;
	}

	String getColor() {
		return color;
	}

	// methods for moving absolutely
	void moveTo(int xNew) {
		x = xNew;
	}

	void moveTo(int xNew, int yNew) {
		x = xNew;
		y = yNew;
	}

	// method for moving relatively
	void moveRel(int dx, int dy) {
		x = x + dx;
		y += dy;
	}

	// method for calculating the distance to the origin
	double distance() {
		return Math.sqrt(x*x + y*y);
	}

	 // method: distance to another Point
	 double distance(Point p) {
			int dx = x - p.getX();
			int dy = y - p.getY();
			return Math.sqrt(dx*dx + dy*dy);
	 }

	// method for changing the color
	void setColor(String colorNew) {
		color = colorNew;
	}
}
