/**
 * A class for rational numbers
 */
public class Rational {

	// instance variables
	private int num;
	private int denom;

	// Constructors
	public Rational() {
		num = 0;
		denom = 1;
	}

	public Rational(int n) {
	   num = n;
	   denom = 1;
	}

	public Rational(int numInit, int denomInit) {
	   num = numInit;
	   denom = denomInit;
	}

	// method: calculate gcd of num and denom
	int gcd() {
		int x = num;
		int y = denom;

		if (num == 0) 
			return denom;

		if (x < 0)
			x = -x;
		if (y < 0) 
			y = -y;

		while (x != y) 
			if (x > y)
				x = x - y;
			else
				y = y - x;

		return x;
	}

	// method: reduce
	public void reduce() {
		int gcd = gcd();
		num /= gcd;
		denom /= gcd;
	}

	// method: extend
	public void extend(int factor) {
		num *= factor;
		denom *= factor;
	}

	// method: print as a/b
	public String toString() {
		return (num + "/" + denom);
	}

	// method: print reduced
	public String toStringReduced() {
		reduce();
		return toString();
	}
}

